package com.link.core.mq.config;

import com.link.core.util.BeanTools;
import com.link.core.util.StringUtils;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.Map;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

@Component
public class MqDispatcher {
   public void invoke(String operationMapping, Object objParam) throws NoSuchMethodException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
      if (StringUtils.isBlank(operationMapping)) {
         throw new NoSuchMethodException(" MqOperationMapping注解的标识为空。");
      } else {
         String SlashStr = "/";
         operationMapping = this.trim(operationMapping, SlashStr);
         ApplicationContext wac = BeanTools.getApplicationContext();
         Map<String, Object> beansWithAnnotationMap = wac.getBeansWithAnnotation(MqOperationMapping.class);
         Class<? extends Object> clazz = null;
         Object bean = null;
         Iterator var8 = beansWithAnnotationMap.entrySet().iterator();

         while(true) {
            String classMapping;
            do {
               if (!var8.hasNext()) {
                  throw new NoSuchMethodException("【" + operationMapping + "】没有找到对应的方法，请检查'MqOperationMapping'的值是否正确 或者 对应的方法修饰符为非'public'");
               }

               Map.Entry<String, Object> entry = (Map.Entry)var8.next();
               bean = entry.getValue();
               clazz = bean.getClass();
               classMapping = ((MqOperationMapping)clazz.getAnnotation(MqOperationMapping.class)).value();
               classMapping = this.trim(classMapping, SlashStr);
            } while(!operationMapping.startsWith(classMapping));

            Method[] methodArr = clazz.getMethods();
            Method[] var12 = methodArr;
            int var13 = methodArr.length;

            for(int var14 = 0; var14 < var13; ++var14) {
               Method md = var12[var14];
               if (md != null && md.isAnnotationPresent(MqOperationMapping.class)) {
                  String methodMapping = ((MqOperationMapping)md.getAnnotation(MqOperationMapping.class)).value();
                  methodMapping = this.trim(methodMapping, SlashStr);
                  if (StringUtils.equals(classMapping + SlashStr + methodMapping, operationMapping)) {
                     md.invoke(bean, objParam);
                     return;
                  }
               }
            }
         }
      }
   }

   private String trim(String source, String beTrim) {
      if (source == null) {
         return "";
      } else {
         source = source.trim();
         if (source.isEmpty()) {
            return "";
         } else {
            String beginChar = source.substring(0, 1);
            if (beginChar.equalsIgnoreCase(beTrim)) {
               source = source.substring(1, source.length());
               beginChar = source.substring(0, 1);
            }

            String endChar = source.substring(source.length() - 1, source.length());
            if (endChar.equalsIgnoreCase(beTrim)) {
               source = source.substring(0, source.length() - 1);
               endChar = source.substring(source.length() - 1, source.length());
            }

            return source;
         }
      }
   }
}
